; File:         Imagem2.asm
; by:           Rui Loureiro
;===============================================================================================
; Assembler directives
;-----------------------------------------------------------------------------------------------
.586                    ; specifies the processor our program want run on
.Model Flat , StdCall   ; always the same for Win95 (32 Bit)
option casemap:none     ; case sensitive !!!
.mmx
;===============================================================================================
        include \masm32\include\windows.inc
        include \masm32\macros\macros.asm
        ;
        include \masm32\include\kernel32.inc
        include \masm32\include\user32.inc
        include \masm32\include\gdi32.inc
        include \masm32\include\advapi32.inc            ; system
        include \masm32\include\secur32.inc             ; system
        
        include \masm32\include\winspool.inc            ; impressora
        include \masm32\include\winmm.inc               ; som
        
        include \masm32\include\comdlg32.inc

        include \masm32\include\masm32.inc
        include \masm32\include\Comctl32.inc
        include \masm32\include\shell32.inc
        include \masm32\include\oleaut32.inc

        include \masm32\include\dialogs.inc
        ;**************************************
                includelib \masm32\lib\kernel32.lib
                includelib \masm32\lib\user32.lib
                includelib \masm32\lib\gdi32.lib
                includelib \masm32\lib\advapi32.lib
                includelib \masm32\lib\secur32.lib
                
                includelib \masm32\lib\winspool.lib
                includelib \masm32\lib\winmm.lib            ; som
                
                includelib \masm32\lib\comdlg32.lib

                includelib \masm32\lib\masm32.lib
                includelib \masm32\lib\Comctl32.lib
                includelib \masm32\lib\shell32.lib
                includelib \masm32\lib\oleaut32.lib

;===============================================================================================
WinMain     proto   :DWORD,:DWORD,:DWORD,:DWORD
CmdProc     proto   :DWORD,:DWORD,:DWORD,:DWORD
WndProcA    proto   :DWORD,:DWORD,:DWORD,:DWORD
;===============================================================================================
;                           Constantes e Estruturas
;----------------------------------------------------------------------------------------------
.const

MAIN_STYLE       equ WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_HSCROLL or WS_VSCROLL
MAIN_EXTSTYLE    equ 300h
$ECRAWIDTH       equ 600  ;1280    ;800                     ; largura do ecr
$ECRAHEIGHT      equ 300  ;800     ;570                     ; altura do ecr
;MAXSIZE          equ 260 

IDM_Menu0_1      equ 1001
IDM_Menu0_2      equ 1002
;  Data Section 
.data
                                                
align 4
;_IconName           db "TDIcon",0                      ; icon name in rc file
align 4
_TDBitmap1          db "TDBitmap1", 0                  ; Logotipo

;....................................................................................
_MenuName    db 'Menu',0        ; Definido em rsrc.rc
;----------------------------------------
_ClassName   db 'WinClass',0
_WindowName  db 'Set Image',0
_Image       db 'rogue.bmp', 0
;  Data? Section 
.data?
;---------------------------------------
_wcx         WNDCLASSEX <?>
_msg         MSG <?>
_x           dd ?
_y           dd ?
_icc 		 INITCOMMONCONTROLSEX <?>

_hInstance   dd ?
_hWnd        dd ?
_hdc         dd ?

_ClientDimX     dd ?
_ClientDimY     dd ?
;  Code Section 
.code
;---------------------------------------
start:
    invoke  GetModuleHandle, NULL
    mov     _hInstance, eax

    invoke    InitCommonControlsEx, ADDR _icc    

    invoke  WinMain, _hInstance, NULL, NULL, SW_SHOWDEFAULT

; ##############################################################################################
align 16
WinMain     proc    hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD
                             
            ; Window size and coordinates to center it on the screen
            ;-------------------------------------------------------
            invoke  GetSystemMetrics, SM_CXSCREEN
            shr     eax, 1
            sub     eax, $ECRAWIDTH / 2
            mov     _x, eax
            invoke  GetSystemMetrics, SM_CYSCREEN
            shr     eax, 1
            sub     eax, $ECRAHEIGHT / 2
            sub     eax, 80
            mov     _y, eax
            ;.................................................................
            ;
            ; Preencher a estrutura WNDCLASSEX para a janela 1
            ; ------------------------------------------------
	      mov   _wcx.cbSize,      SIZEOF WNDCLASSEX
            mov   _wcx.style,       3 or CS_BYTEALIGNCLIENT or CS_OWNDC
    	      mov   _wcx.lpfnWndProc, OFFSET WndProcA
        	mov   _wcx.cbClsExtra,  NULL
	      mov   _wcx.cbWndExtra,  NULL
	      push  _hInstance
	      pop   _wcx.hInstance
            ;invoke  CreateSolidBrush, 0 ;  invoke  GetSysColor, COLOR_BACKGROUND 
        	;mov   _wcx.hbrBackground, COLOR_WINDOW+1       
        	mov   _wcx.hbrBackground, COLOR_BACKGROUND+1           
                   
	      mov   _wcx.lpszMenuName, offset _MenuName              ; menu name in resource file
	      mov   _wcx.lpszClassName, OFFSET _ClassName            ; name of windows class

            ;invoke LoadIcon, hInst, offset _IconName 
            mov     eax, 0
                
            mov    _wcx.hIcon, eax
            mov    _wcx.hIconSm, NULL
        	invoke LoadCursor, NULL, IDC_ARROW
        	mov   _wcx.hCursor, eax

            invoke RegisterClassEx, addr _wcx

            ; ---------------------------------------
            ; Cria a janela: WS_HSCROLL or WS_VSCROLL	
            ; ---------------------------------------
	      invoke CreateWindowEx, MAIN_EXTSTYLE, addr _ClassName, addr _WindowName, MAIN_STYLE,
                                   _x, _y, $ECRAWIDTH, $ECRAHEIGHT, 
                                   NULL, NULL, hInst, NULL
            mov      _hWnd, eax                                     
            
            invoke   GetDC, _hWnd
            mov      _hdc, eax 

            invoke      ShowWindow, _hWnd, SW_SHOWNORMAL

            invoke      UpdateWindow, _hWnd           
;###################################################################
            ;
            ; Loop de espera de mensagens
            ;
@@:         invoke  GetMessage, ADDR _msg, NULL, 0, 0                       
            cmp     eax,0h                              ;check if return value=0 => exit
            je      @F                                  ;go forward @@

            invoke  TranslateMessage, ADDR _msg 
            invoke  DispatchMessage,  ADDR _msg
            jmp     @B                                  ;go backward @@                  
            ;
            ; Termina o programa
            ;-------------------
@@:         invoke  ExitProcess, 0          
WinMain     endp
; 
WndProcA        proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

                mov     edx, wParam
                mov     eax, uMsg
                cmp     eax, WM_PAINT
                je      _WM_PAINT

                cmp     eax, WM_SIZE
                je      _WM_SIZE
                
                cmp     eax, WM_CLOSE
                je      _WM_CLOSE

                cmp     eax, WM_DESTROY
                je      _WM_DESTROY
                
                cmp     eax, WM_SYSCOMMAND
                je      _WM_SYSCOMMAND
; -----------------------------------------------------------------
_EndProcA::     invoke   DefWindowProc, hWnd, uMsg, wParam, lParam
                ret
; 
; -----------------------------------------------------------------
;                             WM_SIZE
; -----------------------------------------------------------------
_WM_SIZE::      mov     edx, lParam         
                mov     eax, edx
                ;
                and     edx, 00FFFFh
                mov     _ClientDimX, edx

                shr     eax, 16                
                mov     _ClientDimY, eax

                jmp       _ExitProcA
; -----------------------------------------------------------------
;                             WM_CREATE
; -----------------------------------------------------------------
_WM_CREATE::    
                jmp       _ExitProcA
; -----------------------------------------------------------------
;                             WM_PAINT
; -----------------------------------------------------------------
_WM_PAINT::     
                call    PrintImage
                jmp     _EndProcA
; -----------------------------------------------------------------
;                             WM_SYSCOMMAND
; -----------------------------------------------------------------
_WM_SYSCOMMAND: cmp     edx, SC_CLOSE
                jne     _EndProcA
; -----------------------------------------------------------------
;                             WM_CLOSE
; -----------------------------------------------------------------
_WM_CLOSE::     invoke    DestroyWindow,  hWnd
                jmp       _ExitProcA
; -----------------------------------------------------------------
;                             WM_DESTROY
; -----------------------------------------------------------------
_WM_DESTROY:    invoke   PostQuitMessage, NULL
                ;
_ExitProcA::    mov     eax, 0
                ret
WndProcA        endp
; 
$DIMx$      equ 140
$DIMy$      equ 105
PrintImage      proc
                LOCAL   hBmp, hMemDC, x, y:DWORD

                mov     eax, _ClientDimX
                sub     eax, $DIMx$
                shr     eax, 1
                mov     x, eax
                
                mov     eax, _ClientDimY
                sub     eax, $DIMy$
                shr     eax, 1
                mov     y, eax
                   
                ;invoke  LoadBitmap, _hInstance, addr _TDBitmap1
                invoke  LoadImage, _hInstance, addr _Image, IMAGE_BITMAP,140, 105, LR_LOADFROMFILE
                ;invoke  LoadImage, _hInstance, addr _Image, IMAGE_BITMAP,0, 0, LR_LOADREALSIZE 
                mov     hBmp,eax
                invoke  CreateCompatibleDC, _hdc
                mov     hMemDC,eax
                invoke  SelectObject,hMemDC, hBmp
                push    eax
                ;invoke  StretchBlt,_hdc,x,y,$DIMx$,$DIMy$,hMemDC,0,0,140,105,SRCCOPY
                invoke  BitBlt,_hdc,x,y,$DIMx$,$DIMy$,hMemDC,0,0,SRCCOPY

                pop     eax
                invoke  SelectObject, hMemDC,eax
                invoke  DeleteObject, hBmp
                invoke  DeleteDC, hMemDC
                ret
PrintImage      endp
; 
    end     start
